/***************************************************************************
                          JollyRoger.h  -  description
                             -------------------
    begin                : Sun May 25 2003
    copyright            : (C) 2003 by Tyler Montbriand
    email                : tsm@accesscomm.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __JOLLYROGER_H__
#define __JOLLYROGER_H__

#include <spritelib/spritelib.h>
#include "GameGrid.h"
#include "Game.h"
#include "TimeSprite.h"

class Bonus:public TimeDelaySprite
{
public:
  Bonus():TimeDelaySprite(RandRange(2000,20000))
  {
    RandPos();
  }

  virtual Uint32 OnTimer(Uint32 interval)
  {
    Expire();
    return(interval);
  }

  void RandPos()
  {
    Sfxp x=-1,y=-1;
    G_GetRandPos(&x,&y);
    MoveTo(x,y);
  }  
};


class FreeLife:public Bonus
{
public:
  FreeLife():Bonus()  {  }

  virtual void Event(int type, void *data1, void *data2)
  {
    switch(type)
    {
    case GAME_EVENT_NUKE:
      PushUserEvent(GAME_EVENT_EXPLOSION,(void *)Xfxp(),(void *)Yfxp());            
    case GAME_EVENT_PLAYERDIED:
      Expire();
      break;
      
    default:
      break;
    }
  }

  virtual void OnCollide(const Sprite *spr, ColType index)
  {    
    PushUserEvent(GAME_EVENT_FREELIFE);
    Expire();
  }  
};

class JollyRoger:public Bonus
{
public:
  JollyRoger():Bonus() {  }
  
  virtual void Event(int code, void *data1=NULL, void *data2=NULL)
  {
    switch(code)
    {
    case GAME_EVENT_NUKE:
      PushUserEvent(GAME_EVENT_EXPLOSION,(void *)Xfxp(),(void *)Yfxp());    
    case GAME_EVENT_PLAYERDIED:
      Expire();
      break;
      
    default:
      break;
    }
  }

  virtual void OnCollide(const Sprite *spr, ColType index)
  {
    if(index==GAME_LAYER_HERO)  Expire();
    else
    {
      PushUserEvent(GAME_EVENT_PLAYSFX,(void *)GAME_SOUND_LAUGH,this);
      RandPos();
    }
  }
  
protected:
  SDL_TimerID timer;
};


class Nuke:public Bonus
{
public:
  Nuke():Bonus()  {  }

  virtual void Event(int type, void *data1, void *data2)
  {
    switch(type)
    {
    case GAME_EVENT_NUKE:
      /* Falls through to GAME_EVENT_PLAYERDIED */      
    case GAME_EVENT_PLAYERDIED:
      Expire();
      break;
          
    default:
      break;
    }
  }

  virtual void OnCollide(const Sprite *spr, ColType index)
  {
    if(index==GAME_LAYER_HERO)
    {
      PushUserEvent(GAME_EVENT_NUKE);
      Expire();
    }
  }
};

class GameOver:public TimeDelaySprite
{
public:
  GameOver():TimeDelaySprite(2500)
  {
    MoveTo(0,0);
    vel.SetFxp(0,50);
  }

  void AlignCenter()
  {
    Sfxp y=Yfxp();
    Sfxp x=((GOFF_X+GMAX_X+GRID_X)/2)-(TO_SFXP(frames.w)/2);
    MoveTo(x,y);
  }

  virtual Uint32 OnTimer(Uint32 interval)
  {
    SDL_Event event;
    event.type=SDL_QUIT;
    SDL_PushEvent(&event);
    Expire();
    return(interval);
  }
};


#endif/*__JOLLYROGER_H__*/
