/***************************************************************************
                          PauseSprite.h  -  description
                             -------------------
    begin                : Wed May 28 2003
    copyright            : (C) 2003 by Tyler Montbriand
    email                : tsm@accesscomm.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef __PAUSESPRITE_H__
#define __PAUSESPRITE_H__

#include <spritelib/spritelib.h>
#include "GameGrid.h"

/*! \brief A simple sprite to display a caption until the game is unpaused  */
class PauseSprite:public Sprite
{
public:
  /*! \brief Constructor ensures sprite is deleted on expiration  */
  PauseSprite():Sprite()
  {
    SetFlags(SPRITE_DELETEABLE);    
  }

  /*! \brief Moves the sprite into the center of the game board */
  void AlignCenter()
  {
    Sfxp y=((GOFF_Y+GMAX_Y+GRID_Y)/2)-(TO_SFXP(frames.h)/2);
    Sfxp x=((GOFF_X+GMAX_X+GRID_X)/2)-(TO_SFXP(frames.w)/2);
    MoveTo(x,y);
  }

  /*! \brief SDL_USEREVENT handler.  Sprite expires when game unpaused.  */
  virtual void Event(int code, void *data1=NULL, void *data2=NULL)
  {
    if(code==GAME_EVENT_UNPAUSE)  Expire();
  }
};

#endif/*__PAUSESPRITE_H__*/
