/***************************************************************************
                          TimeSprite.h  -  description
                             -------------------
    begin                : Sun May 25 2003
    copyright            : (C) 2003 by Tyler Montbriand
    email                : tsm@accesscomm.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __TIMESPRITE_H__
#define __TIMESPRITE_H__
 
#include <spritelib/spritelib.h>
#include "InitSDL.h"

/*! \brief A sprite with time-delay action  */
class TimeDelaySprite:public Sprite
{
public:
  /*! \brief Constructor, takes a delay in milliseconds */
  TimeDelaySprite(Sint32 delay)
  {    
    SetFlags(SPRITE_DELETEABLE);
    timer=SDL_AddTimer(delay,TCallback,this);
  }

  /*! \brief Static callback function that calls virtual callback function  */
  static Uint32 TCallback(Uint32 interval, void *data)
  {
    TimeDelaySprite *spr=(TimeDelaySprite *)data;
    return(spr->OnTimer(interval));
  }

  /*! \brief Virtual callback function  */
  virtual Uint32 OnTimer(Uint32 val)  { return(val); }

  /*! \brief Destructor, destoys timer  */
  virtual ~TimeDelaySprite()
  {
    SDL_RemoveTimer(timer);
  }
protected:
  /*! \brief The timer object */
  SDL_TimerID timer;
};

#endif/*__TIMESPRITE_H__*/
