/***************************************************************************
                          Titlescreen.cpp  -  description
                             -------------------
    begin                : Sat May 10 2003
    copyright            : (C) 2003 by Tyler Montbriand
    email                : tsm@accesscomm.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "Titlescreen.h"
#include "InitSDL.h"
#include "Game.h"

void CLS();
void Paint();

int Titlescreen(void)
{
  int running=1;

  Game_Init(); 

  Paint();

  while(running)
  {
    SDL_Event event;

    SDL_Delay(10);

    while(SDL_PollEvent(&event))
    switch(event.type)
    {
    int keystate;
    
    case SDL_QUIT:
      return(-1);
      break;      

    case SDL_KEYDOWN:
      keystate=SDL_GetModState();    
      switch(event.key.keysym.sym)
      {
      case SDLK_RETURN:
      case SDLK_KP_ENTER:
        if(keystate&(KMOD_LALT|KMOD_RALT))
        {
          ToggleFullscreen();
          Paint();          
        }
        break;
        
      case SDLK_F1:
        return(0);
        break;

      case SDLK_ESCAPE:
        return(-1);
        break;
        
      default:
        break;
      }      
    }
  }
  
  return(-1);
}

void CLS()
{
  SDL_Surface *screen=SDL_GetVideoSurface();
  if(screen==NULL) return;
  SDL_FillRect(screen,NULL,0);
  SDL_Flip(screen);
}

void Paint()
{
  VCS_Surface *screen=VCS_GetVideoSurface();
  if(screen==NULL) return;
  VCS_Surface *title=Game_GetTitle();
  
  if(title!=NULL)
  {
    VCS_BlitSurface(title,NULL,screen,NULL);
    VCS_Flip(screen);
  }
  else
  {
    CLS();
  }
}
