/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Thu May  1 19:00:04 CST 2003
    copyright            : (C) 2003 by Tyler Montbriand
    email                : tsm@accesscomm.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdlib.h>
#include "InitSDL.h"
#include "Titlescreen.h"
#include "Game.h"

/*! \brief The default framerate, in frames per second */
#define DEFAULT_FRAMERATE 150

/*! \brief The main function called by SDL */
int main(int argc, char *argv[])
{
  /* Event loop variable, set to 0 to stop the loop. */
  int running=1;
  /* Frame rate */  
  int frametick=1000/DEFAULT_FRAMERATE;
  /* main's return value */
  int retval=0;  

  /* Attempts to initialize SDL, SDL_mixer, and videomode */
  if(Init(320,240,0)<0)
  {
    fprintf(stderr,"Couldn't initialize.\n");
    return(1);
  }

  while(running)
  {
    /* Run the titlescreen and get response from user */
    int retval=Titlescreen();

    if(retval<0)/* User said quit */
    {
      fprintf(stderr,"Normal exit\n");
      running=0;
    }
    else  /* User said to run the game */
    {
      if(Game(frametick)<0) /* Run the game */
      {
        fprintf(stderr,"Error executing Game(), abnormal exit...\n");
        running=0;  /* Game returned an error, so quit */
        retval=1;   /* Nonzero return code denotes error */
      }
    }
  }

  Game_Quit();   /* Deinitialize the game          */
  Quit();        /* Deinitailize SDL_mixer and SDL */
  return(retval);/* Return success or failure      */
}

